package com.link.core.util.json;

import com.link.core.basic.service.BasicServiceException;
import com.link.core.util.StringUtils;
import org.apache.http.util.Asserts;

public class ObjectOperaUtils {
   public static String getIncludeFieldString(Object obj, String includeField) throws Exception {
      Asserts.check(!isBaseType(obj), "当前对象为基本对象，无法转换");
      if (isBaseType(obj)) {
         throw new BasicServiceException("当前对象为基本对象，无法转换");
      } else if (StringUtils.isBlank(includeField)) {
         throw new BasicServiceException("参数异常，不存在保留字段");
      } else if ("*".equals(includeField)) {
         return JackJsonUtils.obj2JsonStr(obj);
      } else {
         JacksonJsonFilter jsonFilter = new JacksonJsonFilter();
         jsonFilter.include(includeField.split(","));
         return JackJsonUtils.obj2JsonStr(jsonFilter, obj);
      }
   }

   public static String getIgnoreFieldString(Object obj, String ignoreField) throws Exception {
      Asserts.check(!isBaseType(obj), "当前对象为基本对象，无法转换");
      if (isBaseType(obj)) {
         throw new BasicServiceException("当前对象为基本对象，无法转换");
      } else if (StringUtils.isBlank(ignoreField)) {
         throw new BasicServiceException("参数异常，不存在忽略字段");
      } else {
         JacksonJsonFilter jsonFilter = new JacksonJsonFilter();
         jsonFilter.ignore(ignoreField.split(","));
         return JackJsonUtils.obj2JsonStr(jsonFilter, obj);
      }
   }

   public static boolean isBaseType(Object object) {
      Class className = object.getClass();
      return className.equals(Integer.class) || className.equals(Byte.class) || className.equals(Long.class) || className.equals(Double.class) || className.equals(Float.class) || className.equals(Character.class) || className.equals(Short.class) || className.equals(Boolean.class);
   }
}
